// Form.h : CForm ̐錾

#ifndef __FORM_H_
#define __FORM_H_

#include <list>
using namespace std;

#include "resource.h"       // C V{
#include "control.h"

/////////////////////////////////////////////////////////////////////////////
// CForm
class ATL_NO_VTABLE CForm : 
	public CComObjectRootEx<CComSingleThreadModel>,
//	public CComCoClass<CForm, &CLSID_Form>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CForm>,
	public IDispatchImpl<IForm, &IID_IForm, &LIBID_SERAPHYSCRIPTTOOLSLib>
{
public:
	CForm()
	{
		m_hOwner = NULL;
		m_dwControlColor = ::GetSysColor(COLOR_WINDOW);
		m_hBrushControlBkColor = CreateSolidBrush(m_dwControlColor);
		ClearControls(); // 
		// fBtHg̃EBhẼTCY
		m_nWindowWidth  = 0;
		m_nWindowHeight = 0;
	}
	void FinalRelease();

//DECLARE_REGISTRY_RESOURCEID(IDR_FORM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CForm)
	COM_INTERFACE_ENTRY(IForm)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CForm)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IForm
public:
	HWND GetAttachedOwner();
	BOOL FindControlEventName(int eventcode,BSTR* pEventName);
	HBRUSH GetControlColorBrush();
	DWORD GetControlColor();
	STDMETHOD(get_ControlColor)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_ControlColor)(/*[in]*/ long newVal);
	STDMETHOD(CheckListView)(/*[in,optional]*/VARIANT colum,/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(EditListView)(/*[in,optional]*/VARIANT colum,/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(ListView)(/*[in,optional]*/VARIANT colum,/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(TreeView)(/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(DropdownEdit)(/*[in,optional]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(DropdownList)(/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(MultiListBox)(/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(ListBox)(/*[in,optional]*/VARIANT width,/*[in,optinal]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	void EnableAllControl(BOOL mode);
	STDMETHOD(get_RightMargin)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_RightMargin)(/*[in]*/ short newVal);
	void SetWindowSize(int width,int height,BOOL bThick);
	void DetachOwner();
	void AttachOwner(HWND hOwner);
	STDMETHOD(get_Control)(/*[in]*/VARIANT varNum, /*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(SetControlFont)(/*[in]*/VARIANT fontname,/*[in]*/VARIANT fontsize);
	STDMETHOD(ControlUseStaticEdge)(/*[in]*/VARIANT mode);
	STDMETHOD(StatusLabel)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(PushRadioButton)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(PushCheckButton)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(CheckBox3state)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(ReadonlyEdit)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* punkVal);
	STDMETHOD(PasswordEdit)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(ControlPad)(/*[in]*/VARIANT width,/*[in,optional]*/VARIANT height);
	STDMETHOD(RadioButton)(/*[in]*/VARIANT text,/*[in]*/VARIANT width,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(ControlGroup)();
	STDMETHOD(ControlBreak)();
	STDMETHOD(get_LeftMargin)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_LeftMargin)(/*[in]*/ short newVal);
	STDMETHOD(ClearControls)();
	STDMETHOD(Edit)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[in,optional]*/VARIANT height,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(CheckBox)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[out,retval]*/VARIANT* pvarUnk);
	STDMETHOD(Button)(/*[in]*/VARIANT text,/*[in]*/VARIANT width,/*[out,retval]*/ VARIANT *pvarUnk);
	STDMETHOD(Label)(/*[in]*/VARIANT text,/*[in,optional]*/VARIANT width,/*[out,retval]*/VARIANT* pvarUnk);
protected:
	CControl* CreateControlCore(VARIANT& text,VARIANT& width,VARIANT& height,VARIANT* pvarUnk,DWORD extstyle,DWORD style,DWORD afterstyle,LPCSTR classname);
	list<CComObject<CControl>*> m_lstControl;
	BOOL m_bControlUseStaticEdge;
	BOOL m_bControlNextIsGroupHead;
	int m_nCommandID;
	int m_nControlNextY;
	int m_nControlFontSize;
	int m_nControlNextX;
	int m_nControlLeftMargin;
	int m_nControlRightMargin;
	HFONT m_hControlFont;
	int m_nControlNextY0;
	HWND m_hOwner;
	int m_nWindowWidth;
	int m_nWindowHeight;
	DWORD m_dwControlColor;
	HBRUSH m_hBrushControlBkColor;
};

#endif //__FORM_H_
